package Qt::_internal;
use strict;

sub KDE::Application::NEW {
    my $class = shift;
    my ($argv, $count);
    if( defined $_[0] and ref $_[0] eq 'ARRAY' ) {
        $argv = shift;
        unshift @$argv, $0;
        $count = scalar @$argv;
    }
    setInConstructor(1);
    setThis( bless KDE::Application::KApplication($argv ? ($count, $argv, @_) : @_), " $class" );
    setInConstructor(0);
    setAllocated(this(), 1);
    setqapp(this());
    shift @$argv if $argv;
}

sub KDE::CmdLineArgs::init {
    $Qt::AutoLoad::AUTOLOAD = 'KDE::CmdLineArgs::init';
    my $autoload = "KDE::CmdLineArgs::_UTOLOAD";
    no strict 'refs';
    if( defined $_[0] and ref $_[0] eq 'ARRAY' ) {
        my $argv = shift;
        unshift @$argv, $0;
        my $count = scalar @$argv;
        $autoload->($count, $argv, @_);
    } else {
        $autoload->(@_);
    }
}

1;

package KDE;

use 5.006;
use strict;
use warnings;
use XSLoader;

require Exporter;

our $VERSION = '3.009';
our @EXPORT = qw(&SIGNAL &SLOT &CAST &emit &min &max);

$Qt::VERSION = $VERSION;

# try to avoid KDE's buggy malloc
# only works for --enable-fast-malloc,
# not when --enable-fast-malloc=full
$ENV{'KDE_MALLOC'} = 0;

if (exists $::INC{"Qt.pm"}) {
    require Carp;
    Carp::croak("Loading the KDE extension after the Qt extension is currently unsupported. KDE must come first\n")
}

XSLoader::load 'KDE', $VERSION;

require Qt;
unless ($VERSION eq $Qt::VERSION) { 
    require Carp; 
    Carp::croak("KDE vs. Qt module version mismatch ($VERSION vs. $Qt::VERSION).\n")
}
import Qt;

sub import { goto &Exporter::import }
sub app { goto &Qt::app }

1;
