#!/usr/bin/perl -w

# derived by Richard Dale
# from the EventFilter example, Chapter 16 of 'Programming with Qt' by Matthias Kalle Dalheimer. 
# Copyright 1999 O'Reilly & Associates.

use strict;
package KillerFilter;
use Qt;
use Qt::isa qw(Qt::Object);

	sub eventFilter( $$ )
	{
		my ($object, $event) = @_;
		if ($event->type() == &Qt::Event::MouseButtonPress) {
			if ( $event->button() == &RightButton ) {
				$object->close(0);
				return 1;
			} else {
				return 0;
			}
		} else {
			return 0;
		}
	}
	
1;

package main;

use Qt;
use KillerFilter;

my $a = Qt::Application(\@ARGV);
	
my $toplevel = Qt::Widget;
$toplevel->resize(300, 150);
$toplevel->setCaption( "Right click any widget" );

my $killerfilter = KillerFilter

my $pb = Qt::PushButton($toplevel);
$pb->setGeometry( 10, 10, 135, 60 );
$pb->setText("pushbutton");
$pb->installEventFilter($killerfilter);

my $le = Qt::LineEdit($toplevel);
$le->setGeometry( 10, 80, 135, 60 );
$le->setText("Line edit");
$le->installEventFilter($killerfilter);

my $cb = Qt::CheckBox($toplevel);
$cb->setGeometry( 155, 10, 135, 60 );
$cb->setText("Check-box");
$cb->installEventFilter($killerfilter);

my $rb = Qt::RadioButton($toplevel);
$rb->setGeometry( 155, 80, 135, 60 );
$rb->setText("Radio button");
$rb->installEventFilter($killerfilter);

$a->setMainWidget($toplevel);
$toplevel->show();
$a->exec();


	
