use threads;
use threads::shared;

package Foo;

use Qt;
use Qt::isa qw( Qt::PushButton );
use Qt::attributes qw(
    shared_var
);

sub NEW {
    shift->SUPER::NEW($_[0]);
    shared_var = $_[1];
    resize(320,100);
    Qt::Object::connect( this, SIGNAL 'clicked()', this, SLOT  'do_something()' );
    setCaption("look STDOUT for count");
    setText( "Read shared counter" )
}

sub do_something : SLOT() {
    lock( this->{shared_var} );
    setText("Here it is: ".${ &shared_var });
}

1;

package main;

use Qt;
use Foo;

my $a = Qt::Application();
my $shared : shared;
$w = Foo(undef, \$shared);

$a->setMainWidget($w);
my $thread = threads->create("a_thread", 1);
my $thread2 = threads->create("a_thread", 2);

$w->show;
$a->exec;

sub a_thread {
    my $interval = shift;
    while(1) {
       sleep $interval;
       lock($shared);
       $shared++;
       print "Counter from thread $interval: $shared\n";
    }
}

